// main application

/*
#########################################################
#   Program to convert wave into octave matrix          #
#                                                       #
#   Peeter Vois peeter@tauria.ee 2012                   #
#                                                       #
#   Copyright (C) 2012 Peeter Vois                      #
#   Licence: GNU GPL v2 or any later version            #
#########################################################
*/


#include "UT2XXX.h"
#include <octave/oct.h>

DEFUN_DLD(dso_unitrend, , ,
          "Get data from digital storage oscilloscope of unitrend UTD2202CE.")
{
	// todo: add parameters for vendor id and product id, in case these are not
	// hardcoded, user can specify from octave
	UNI_TREND_DSO dso(0,0);

	double from_dso[250][3]; // x, y1, y2
	Matrix d(250,3);

	int n = dso.get( (double*)from_dso, 250 );

	if( n == 0 )
		return octave_value((double)0.0);

	for( int i = 0; i<250; i++ )
	for( int j = 0; j<3; j++ )
		d(i,j) = from_dso[i][j];

	return octave_value( d );
}
