#!/usr/bin/octave
#########################################################
#   Helper functions for using dso   UT2XXX             #
#                                                       #
#   Peeter Vois peeter@tauria.ee 2012                   #
#                                                       #
#   Copyright (C) 2012 Peeter Vois                      #
#   Licence: GNU GPL v2 or any later version            #
#########################################################


1;

#the path where the driver will be found

autoload( "dso_unitrend", "/home/peeter/Projektid/octave-unitt/src/dso_unitrend.oct" );

function y = dso_unitrend_allways()
# does reaptemt to load input data when the data loading failed
	y = 0;
	while( rows(y) < 10 )
		y = dso_unitrend();
	endwhile
endfunction

function y = dso_fft_abs( r )
# does calculate fourier transform from dso signal r
# returns 3 xolumn matrix of result:
#  1 - frequency
#  2 - ch1 magnitude
#  3 - ch2 magnitude
	inp = abs( fft(r(:,2) ) );
	out = abs( fft(r(:,3) ) );
	xx = [ 0 : 1/(r(250,1)-r(1,1)) : 1/(r(3,1)-r(1,1)) ];
	y(1:125,1) = xx(1:125);
	y(1:125,2) = inp(1:125);
	y(1:125,3) = out(1:125);
endfunction

function y = dso_fft_transfer( r )
# does calculate spectral transfer from input to output
# returns 2 columns matrix of result:
#  1 - frequency
#  2 - ch2 / ch1 spectra
	x = dso_fft_abs( r );
	xx = x( :, 2 ) <= 0;
	x( :, 2 ) = x( :, 2 ).*(1.-xx) .+ xx.*x( :, 3 );
	y( :, 1) = x( :, 1 );
	y( :, 2) = (x( :, 2 )<=0) .+ x( :, 3 ) ./ x( :, 2 );
endfunction


#ks(250,1)=0;
#s_inp(250,1)=0;
#s_tra(125,1)=0;
#for i = 1:100
#	sig = dso_unitrend_allways();
#	tra = dso_fft_transfer( sig );
#	s_tra = s_tra .+ tra(:,2);
#	semilogy( tra(:,1),  s_tra(:) ./ i );
#	drawnow();
#	printf( "%03d%%\r", i );fflush(stdout);
#	#sleep(1);
#endfor

#input( "press enter:" );
